=== modified file 'linaro_image_tools/media_create/boards.py'
--- linaro_image_tools/media_create/boards.py	2011-04-01 14:18:41 +0000
+++ linaro_image_tools/media_create/boards.py	2011-04-04 16:22:10 +0000
@@ -250,16 +250,15 @@
 
     @classmethod
     def make_boot_files(cls, uboot_parts_dir, is_live, is_lowmem, consoles,
-                        chroot_dir, rootfs_uuid, boot_dir, boot_script_path,
-                        boot_device_or_file):
+                        chroot_dir, rootfs_uuid, boot_dir, boot_device_or_file):
         boot_env = cls._get_boot_env(is_live, is_lowmem, consoles, rootfs_uuid)
         cls._make_boot_files(
-            uboot_parts_dir, boot_env, chroot_dir, boot_dir, boot_script_path,
+            uboot_parts_dir, boot_env, chroot_dir, boot_dir, 
             boot_device_or_file)
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         """Make the necessary boot files for this board.
 
         This is usually board-specific so ought to be defined in every
@@ -287,11 +286,9 @@
             cmd_runner.run(
                 ['cp', '-v', uboot_bin, boot_disk], as_root=True).wait()
 
-        boot_script_path = os.path.join(boot_disk, cls.boot_script)
-
         cls.make_boot_files(
             uboot_parts_dir, is_live, is_lowmem, consoles, chroot_dir,
-            rootfs_uuid, boot_disk, boot_script_path, boot_device_or_file)
+            rootfs_uuid, boot_disk, boot_device_or_file)
 
         cmd_runner.run(['sync']).wait()
         try:
@@ -346,23 +343,23 @@
 
     @classmethod
     def make_boot_files(cls, uboot_parts_dir, is_live, is_lowmem, consoles,
-                        chroot_dir, rootfs_uuid, boot_dir, boot_script_path,
-                        boot_device_or_file):
+                        chroot_dir, rootfs_uuid, boot_dir, boot_device_or_file):
         # XXX: This is also part of our temporary hack to fix bug 697824; we
         # need to call set_appropriate_serial_tty() before doing anything that
         # may use cls.serial_tty.
         cls.set_appropriate_serial_tty(chroot_dir)
         super(OmapConfig, cls).make_boot_files(
             uboot_parts_dir, is_live, is_lowmem, consoles, chroot_dir,
-            rootfs_uuid, boot_dir, boot_script_path, boot_device_or_file)
+            rootfs_uuid, boot_dir, boot_device_or_file)
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         install_omap_boot_loader(chroot_dir, boot_dir)
         make_uImage(
             cls.load_addr, uboot_parts_dir, cls.kernel_suffix, boot_dir)
         make_uInitrd(uboot_parts_dir, cls.kernel_suffix, boot_dir)
+        boot_script_path = os.path.join(boot_dir, cls.boot_script)
         make_boot_script(boot_env, boot_script_path)
         make_boot_ini(boot_script_path, boot_dir)
 
@@ -414,10 +411,11 @@
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         make_uImage(
             cls.load_addr, uboot_parts_dir, cls.kernel_suffix, boot_dir)
         make_uInitrd(uboot_parts_dir, cls.kernel_suffix, boot_dir)
+        boot_script_path = os.path.join(boot_dir, cls.boot_script)
         make_boot_script(boot_env, boot_script_path)
         make_boot_ini(boot_script_path, boot_dir)
 
@@ -440,10 +438,11 @@
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         make_uImage(
             cls.load_addr, uboot_parts_dir, cls.kernel_suffix, boot_dir)
         make_uInitrd(uboot_parts_dir, cls.kernel_suffix, boot_dir)
+        boot_script_path = os.path.join(boot_dir, cls.boot_script)
         make_boot_script(boot_env, boot_script_path)
 
 
@@ -485,13 +484,14 @@
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         uboot_file = os.path.join(
             chroot_dir, 'usr', 'lib', 'u-boot', cls.uboot_flavor, 'u-boot.imx')
         install_mx5_boot_loader(uboot_file, boot_device_or_file)
         make_uImage(
             cls.load_addr, uboot_parts_dir, cls.kernel_suffix, boot_dir)
         make_uInitrd(uboot_parts_dir, cls.kernel_suffix, boot_dir)
+        boot_script_path = os.path.join(boot_dir, cls.boot_script)
         make_boot_script(boot_env, boot_script_path)
 
 
@@ -542,7 +542,7 @@
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         make_uImage(
             cls.load_addr, uboot_parts_dir, cls.kernel_suffix, boot_dir)
         make_uInitrd(uboot_parts_dir, cls.kernel_suffix, boot_dir)
@@ -604,7 +604,7 @@
 
     @classmethod
     def _make_boot_files(cls, uboot_parts_dir, boot_env, chroot_dir, boot_dir,
-                         boot_script_path, boot_device_or_file):
+                         boot_device_or_file):
         uboot_file = os.path.join(
             chroot_dir, 'usr', 'lib', 'u-boot', 'smdkv310', 'u-boot.v310')
         install_smdkv310_boot_loader(uboot_file, boot_device_or_file)
@@ -623,6 +623,7 @@
 
         # unused at the moment once FAT support enabled for the
         # Samsung u-boot this can be used bug 727978
+        #boot_script_path = os.path.join(boot_dir, cls.boot_script)
         #make_boot_script(boot_env, boot_script_path)
 
 

=== modified file 'linaro_image_tools/media_create/tests/test_media_create.py'
--- linaro_image_tools/media_create/tests/test_media_create.py	2011-03-29 13:28:38 +0000
+++ linaro_image_tools/media_create/tests/test_media_create.py	2011-04-04 20:13:55 +0000
@@ -170,7 +170,7 @@
             classmethod(set_appropriate_serial_tty_mock)))
 
     def make_boot_files(self, config):
-        config.make_boot_files('', False, False, [], '', '', '', '', '')
+        config.make_boot_files('', False, False, [], '', '', '', '')
 
     def test_vexpress_steps(self):
         self.make_boot_files(boards.VexpressConfig)
@@ -278,7 +278,7 @@
         # we're only interested in ensuring that OmapConfig.make_boot_files()
         # calls set_appropriate_serial_tty().
         board_configs['beagle'].make_boot_files(
-            None, None, None, None, None, None, None, None, None)
+            None, None, None, None, None, None, None, None)
         self.assertTrue(
             self.set_appropriate_serial_tty_called,
             "make_boot_files didn't call set_appropriate_serial_tty")
@@ -928,10 +928,10 @@
 
     expected_args = (
         'chroot_dir/boot', False, False, [], 'chroot_dir', 'rootfs_uuid',
-        'boot_disk', 'boot_disk/boot_script', 'boot_device_or_file')
+        'boot_disk', 'boot_device_or_file')
     expected_args_live = (
         'chroot_dir/casper', True, False, [], 'chroot_dir', 'rootfs_uuid',
-        'boot_disk', 'boot_disk/boot_script', 'boot_device_or_file')
+        'boot_disk', 'boot_device_or_file')
     expected_calls = [
         'mkdir -p boot_disk',
         '%s mount boot_partition boot_disk' % sudo_args,